package com.foo.hibernate;

import java.util.Iterator;
import java.util.List;

import com.foo.domain.Contact;
import com.foo.domain.ContactDao;
import com.foo.util.QueryParam;

//import org.hibernate.Query;
import org.apache.wicket.extensions.markup.html.repeater.util.SortParam;
import org.hibernate.Query;
import org.hibernate.SessionFactory;

import org.springframework.beans.factory.annotation.Autowired;

import org.springframework.stereotype.Repository;

import org.springframework.transaction.annotation.Transactional;

//import java.util.List;


@Repository("contactDao")
public class HibernateContactDao implements ContactDao {
    private SessionFactory sessionFactory;

    @Autowired
    public void setSessionFactory(SessionFactory sessionFactory) {
        this.sessionFactory = sessionFactory;
    }

    @Transactional
    public void store(Contact contact) {
        sessionFactory.getCurrentSession().saveOrUpdate(contact);
    }

    @Transactional(readOnly = true)
	public Contact get(long id) {
    	return (Contact) sessionFactory.getCurrentSession().get(Contact.class, id);
	}

    @Transactional(readOnly = true)
	public Iterator<Contact> find(QueryParam qp) {

		List<Contact> sublist = getIndex(qp.getSort()).subList(qp.getFirst(),
				qp.getFirst() + qp.getCount());
			return sublist.iterator();
	}
    
	protected List<Contact> getIndex(SortParam sort)
	{
		Query query;
		
		if (sort == null) {
			query = sessionFactory.getCurrentSession().createQuery("from Contact");

	        return query.list();
		}
			

		if (sort.getProperty().equals("firstName"))
		{
			//return sort.isAscending() ? fnameIdx : fnameDescIdx;
			query = sessionFactory.getCurrentSession().createQuery("from Contact");

	        return query.list();
		}
		else if (sort.getProperty().equals("lastName"))
		{
			//return sort.isAscending() ? lnameIdx : lnameDescIdx;
			query = sessionFactory.getCurrentSession().createQuery("from Contact");

	        return query.list();
		}
		throw new RuntimeException("unknown sort option [" + sort +
			"]. valid fields: [firstName], [lastName]");
	}

 
}
